%define glib2_version 2.16.0
%define gtk2_version 2.6.0
%define dbus_version 1.0
%define hal_version 0.5.7
%define gcrypt_version 1.2.2
%define libtasn1_version 0.3.4

Summary: Framework for managing passwords and other secrets
Name: gnome-keyring
Version: 2.28.2
Release: 8%{?dist}
License: GPLv2+ and LGPLv2+
Group: System Environment/Libraries
Source: http://download.gnome.org/sources/gnome-keyring/2.28/gnome-keyring-%{version}.tar.bz2

# https://bugzilla.gnome.org/show_bug.cgi?id=598494
Patch2: gnome-keyring-2.28.0-die-on-session-exit.patch
# https://bugzilla.gnome.org/show_bug.cgi?id=613644
Patch3: gnome-keyring-dir-prefix.patch

# updated translations
# https://bugzilla.redhat.com/show_bug.cgi?id=589203
Patch4: gnome-keyring-translations.patch
Patch5: gnome-keyring-translations-2.patch

# [abrt] gnome-keyring-2.28.2-6.el6: sec_free: Process /usr/bin/gnome-keyring-daemon was killed by signal 6 (SIGABRT)
# https://bugzilla.redhat.com//show_bug.cgi?id=745695
Patch6: gnome-keyring-2.31.92-securefree-pool_free.patch
Patch7: gnome-keyring-2.28.2-secure-memory-locking.patch

# nm-connection-editor gets stuck reading from gnome-keyring
# https://bugzilla.redhat.com/show_bug.cgi?id=574449
Patch8: gnome-keyring-2.28.2-daemon-Uncoditionally-wakeup-the-main-loop-when-lock.patch

URL: http://www.gnome.org
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: glib2-devel >= %{glib2_version}
BuildRequires: gtk2-devel >= %{gtk2_version}
BuildRequires: GConf2-devel
BuildRequires: dbus-devel >= %{dbus_version}
BuildRequires: libgcrypt-devel >= %{gcrypt_version}
BuildRequires: libtasn1-devel >= %{libtasn1_version}
BuildRequires: pam-devel
BuildRequires: libtool
BuildRequires: gettext
BuildRequires: intltool
BuildRequires: libtasn1-tools
Requires(pre): GConf2
Requires(preun): GConf2
Requires(post): GConf2

%description
The gnome-keyring session daemon manages passwords and other types of
secrets for the user, storing them encrypted with a main password.
Applications can use the gnome-keyring library to integrate with the keyring.

%package devel
Summary: Development files for gnome-keyring
License: LGPLv2+
Group: Development/Libraries
Requires: %name = %{version}-%{release}
Requires: glib2-devel
Requires: pkgconfig
# for /usr/share/gtk-doc/html
Requires: gtk-doc

%description devel
The gnome-keyring-devel package contains the libraries and
header files needed to develop applications that use gnome-keyring.

%package pam
Summary: Pam module for unlocking keyrings
License: LGPLv2+
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
# for /lib/security
Requires: pam

%description pam
The gnome-keyring-pam package contains a pam module that can
automatically unlock the "login" keyring when the user logs in.


%prep
%setup -q -n gnome-keyring-%{version}
%patch2 -p1 -b .die-on-session-exit
%patch3 -p1 -b .dir-prefix
%patch4 -p1 -b .translations
%patch5 -p2 -b .translations2
%patch6 -p1 -b .securefree-pool_free
%patch7 -p1 -b .secure-memory-locking
%patch8 -p1 -b .daemon-wakeup

%build
%configure --disable-gtk-doc --with-pam-dir=/%{_lib}/security --disable-acl-prompts
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

# avoid unneeded direct dependencies
sed -i -e 's/ -shared / -Wl,-O1,--as-needed\0 /g' libtool

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
make install install-pam DESTDIR=$RPM_BUILD_ROOT
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL

rm $RPM_BUILD_ROOT/%{_lib}/security/*.la
rm $RPM_BUILD_ROOT%{_libdir}/*.la
rm $RPM_BUILD_ROOT%{_libdir}/gnome-keyring/*.la
rm $RPM_BUILD_ROOT%{_libdir}/gnome-keyring/devel/*.la
rm $RPM_BUILD_ROOT%{_libdir}/gnome-keyring/standalone/*.la

%find_lang gnome-keyring

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/gnome-keyring.schemas > /dev/null || :

%pre
if [ "$1" -gt 1 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/gnome-keyring.schemas > /dev/null || :
fi

%preun
if [ "$1" -eq 0 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/gnome-keyring.schemas > /dev/null || :
fi

%postun -p /sbin/ldconfig

%files -f gnome-keyring.lang
%defattr(-, root, root)
%doc AUTHORS NEWS README COPYING COPYING.LIB
# LGPL
%{_libdir}/lib*.so.*
%dir %{_libdir}/gnome-keyring
%{_libdir}/gnome-keyring/gnome-keyring-pkcs11.so
%{_libdir}/gnome-keyring/devel/*.so
%{_libdir}/gnome-keyring/standalone/*.so
# GPL
%{_bindir}/*
%{_libexecdir}/*
%{_datadir}/dbus-1/services/org.gnome.keyring.service
%{_datadir}/gcr
%{_sysconfdir}/gconf/schemas/gnome-keyring.schemas
%{_sysconfdir}/xdg/autostart/gnome-keyring-daemon.desktop

%files devel
%defattr(-, root, root)
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_includedir}/*
%doc %{_datadir}/gtk-doc/html/gnome-keyring/
%doc %{_datadir}/gtk-doc/html/gp11/
%doc %{_datadir}/gtk-doc/html/gcr/

%files pam
%defattr(-, root, root)
/%{_lib}/security/*.so


%changelog

